MODULE MachineTest;
    
    IMPORT FIQMachine4, HLog, HKernel;
    
CONST
    LEDCONST = 200000;
    DELTA= 10;

VAR LEDON: INTEGER; NOP : BOOLEAN;

PROCEDURE Led*();
    VAR i, j:INTEGER;
BEGIN
    j := 0;
    WHILE j<5 DO
        FOR i := 0 TO LEDON DO HKernel.LED(HKernel.LED2, FALSE); END;
        FOR i := 0 TO LEDON DO HKernel.LED(HKernel.LED2, TRUE); END;
        INC(j);
    END;HKernel.LED(HKernel.LED2, FALSE); 
END Led;

PROCEDURE Led2*();
    VAR i, j :INTEGER;
BEGIN
    j := 0;
    WHILE j < 2 DO
        FOR i := 0 TO LEDON DO HKernel.LED(HKernel.LED3, FALSE); END;
        FOR i := 0 TO LEDON DO HKernel.LED(HKernel.LED3, TRUE); END;
        INC(j);
    END;HKernel.LED(HKernel.LED3, FALSE); 
END Led2;

PROCEDURE Led3*();
    VAR i, j :INTEGER;
BEGIN
    j := 0;
    WHILE j < 1 DO
        FOR i := 0 TO LEDON DO HKernel.LED(HKernel.LED3, FALSE); END;
        FOR i := 0 TO LEDON DO HKernel.LED(HKernel.LED3, TRUE); END;
        INC(j);
    END;HKernel.LED(HKernel.LED3, FALSE); 
END Led3;

PROCEDURE Setup6O(WCET, T, D: INTEGER);
    VAR i, a0, a1, a2, adr: INTEGER; SCODE: BOOLEAN;
BEGIN
    LEDON := WCET; SCODE := TRUE;
    a0 := T DIV 4; a1 := a0*2; a2 := a0*3;
    FOR i := 0 TO T-1 DO 
        IF i < a0 THEN FIQMachine4.tasks[i] := Led
        ELSIF i <a1 THEN FIQMachine4.tasks[i] := Led2
        ELSE FIQMachine4.tasks[i] := Led3
        END;
    END;
    FIQMachine4.NTSK := T;
    
    (* Setup Ecode *)
    (* TIME 0 *)
    FIQMachine4.NINS := 0;
    FOR i :=0 TO a0-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 60, -1);
    END;
    FOR i :=a0 TO a1-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 30, -1);
    END;
    FOR i :=a1 TO a2-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 20, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 10, -1);
    END;
    adr :=FIQMachine4.NINS;
    IF SCODE THEN
        FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr + T+2, -1);
        FOR i :=0  TO T-1 DO
            FIQMachine4.SystemCode(FIQMachine4.DISPATCH, i, 10, adr+T+1);
        END;
    ELSE FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr+2, -1);
    END;
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 10 *)
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 10, -1);
    END;
    adr :=FIQMachine4.NINS;
    IF SCODE THEN
        FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr + T+2, -1);
        FOR i :=0  TO T-1 DO
            FIQMachine4.SystemCode(FIQMachine4.DISPATCH, i, 10, adr + T+1);
        END;
    ELSE FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr+2, -1);
    END;
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 20 *)
    FOR i :=a1 TO a2-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 20, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 10, -1);
    END;
    adr :=FIQMachine4.NINS;
    IF SCODE THEN
        FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr + T+2, -1);
        FOR i :=0  TO T-1 DO
            FIQMachine4.SystemCode(FIQMachine4.DISPATCH, i, 10, adr+T+1);
        END;
    ELSE FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr+2, -1);
    END;
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 30 *)
    FOR i :=a0 TO a1-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 30, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 10, -1);
    END;
    adr :=FIQMachine4.NINS;
    IF SCODE THEN
        FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr + T+2, -1);
        FOR i :=0  TO T-1 DO
            FIQMachine4.SystemCode(FIQMachine4.DISPATCH, i, 10, adr+T+1);
        END;
    ELSE FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr+2, -1);
    END;
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 40 *)
    FOR i :=a1 TO a2-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 20, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 10, -1);
    END;
    adr :=FIQMachine4.NINS;
    IF SCODE THEN
        FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr + T+2, -1);
        FOR i :=0  TO T-1 DO
            FIQMachine4.SystemCode(FIQMachine4.DISPATCH, i, 10, adr+T+1);
        END;
    ELSE FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, adr+2, -1);
    END;
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 50 *)
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 10, -1);
    END;
    adr :=FIQMachine4.NINS;
    IF SCODE THEN
        FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, 0, -1);
        FOR i :=0  TO T-1 DO
            FIQMachine4.SystemCode(FIQMachine4.DISPATCH, i, 10, adr+T+1);
        END;
    ELSE FIQMachine4.SystemCode(FIQMachine4.FUTURE, 10, 0, -1);
    END;
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    HLog.Str("Instructions: "); HLog.Int(FIQMachine4.NINS); HLog.Ln;
END Setup6O;

PROCEDURE Setup6b(WCET, T, D: INTEGER); (* we assume no preemption *)
    VAR i, a0, a1, a2, adr: INTEGER;
BEGIN
    LEDON := WCET;
    a0 := T DIV 4; a1 := a0*2; a2 := a0*3;
    FOR i := 0 TO T-1 DO 
        IF i < a0 THEN FIQMachine4.tasks[i] := Led
        ELSIF i <a1 THEN FIQMachine4.tasks[i] := Led2
        ELSE FIQMachine4.tasks[i] := Led3
        END;
    END;
    FIQMachine4.NTSK := T;
    
    (* Setup Ecode *)
    (* TIME 0 *)
    FIQMachine4.NINS := 0;
    FOR i :=0 TO a0-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 6*D, -1);
    END;
    FOR i :=a0 TO a1-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 3*D, -1);
    END;
    FOR i :=a1 TO a2-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 2*D, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, D, -1);
    END;
    adr := FIQMachine4.NINS;
    FIQMachine4.SystemCode(FIQMachine4.FUTURE, D, adr+3, -1);
    FIQMachine4.SystemCode(FIQMachine4.NOP, -1, -1, -1);
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 10 *)
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, D, -1);
    END;
    adr := FIQMachine4.NINS;
    FIQMachine4.SystemCode(FIQMachine4.FUTURE, D, adr+3, -1);
    FIQMachine4.SystemCode(FIQMachine4.NOP, -1, -1, -1);
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 20 *)
    FOR i :=a1 TO a2-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 2*D, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, D, -1);
    END;
    adr := FIQMachine4.NINS;
    FIQMachine4.SystemCode(FIQMachine4.FUTURE, D, adr+3, -1);
    FIQMachine4.SystemCode(FIQMachine4.NOP, -1, -1, -1);
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 30 *)
    FOR i :=a0 TO a1-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 3*D, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, D, -1);
    END;
    adr := FIQMachine4.NINS;
    FIQMachine4.SystemCode(FIQMachine4.FUTURE, D, adr+3, -1);
    FIQMachine4.SystemCode(FIQMachine4.NOP, -1, -1, -1);
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 40 *)
    FOR i :=a1 TO a2-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, 2*D, -1);
    END;
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i,  D, -1);
    END;
    adr := FIQMachine4.NINS;
    FIQMachine4.SystemCode(FIQMachine4.FUTURE, D, adr+3, -1);
    FIQMachine4.SystemCode(FIQMachine4.NOP, -1, -1, -1);
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 
    (* TIME 50 *)
    FOR i :=a2 TO T-1 DO
        FIQMachine4.SystemCode(FIQMachine4.SCHEDULE, i, D, -1);
    END;
    adr := FIQMachine4.NINS;
    FIQMachine4.SystemCode(FIQMachine4.FUTURE,  D, 0, -1);
    FIQMachine4.SystemCode(FIQMachine4.NOP, -1, -1, -1);
    FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1); 

    HLog.Str("Instructions: "); HLog.Int(FIQMachine4.NINS); HLog.Ln;
END Setup6b;

PROCEDURE Ecode6EDF4*;
BEGIN
    Setup6b(1562, 4, 10);
END Ecode6EDF4;

PROCEDURE Ecode6EDF10*;
BEGIN
    Setup6b(625, 10, 10);
END Ecode6EDF10;

PROCEDURE Ecode6EDF50*;
BEGIN
    Setup6b(125, 50, 10);
END Ecode6EDF50;

PROCEDURE Ecode6EDF100*;
BEGIN Setup6b(62, 100, 10);
END Ecode6EDF100;

PROCEDURE Ecode6wEDF4*;
BEGIN
    Setup6b(1562, 4, 10);
END Ecode6wEDF4;

PROCEDURE Ecode6wEDF10*;
BEGIN
    Setup6b(625, 10, 10);
END Ecode6wEDF10;

PROCEDURE Ecode6wEDF50*;
BEGIN
    Setup6b(80, 50, 10);
END Ecode6wEDF50;

PROCEDURE Ecode6wEDF100*;
BEGIN Setup6b(35, 100, 10);
END Ecode6wEDF100;

PROCEDURE Ecode6EDF4B*;
BEGIN
    Setup6O(1562, 4, 10);
END Ecode6EDF4B;

PROCEDURE Ecode6EDF10B*;
BEGIN
    Setup6O(625, 10, 10);
END Ecode6EDF10B;

PROCEDURE Ecode6EDF50B*;
BEGIN
    Setup6O(125, 50, 10);
END Ecode6EDF50B;

PROCEDURE Ecode6EDF100B*;
BEGIN Setup6O(62, 100, 10);
END Ecode6EDF100B;

PROCEDURE Ecode6WEDF4*;
BEGIN
Setup6b(3000, 4, 10);
END Ecode6WEDF4;

PROCEDURE Ecode6WEDF10*;
BEGIN
    Setup6b(1200, 10, 10);
END Ecode6WEDF10;

PROCEDURE Ecode6WEDF50*;
BEGIN
    Setup6b(240, 50, 10);
END Ecode6WEDF50;

PROCEDURE Ecode6WEDF100*;
BEGIN Setup6b(80, 100, 10);
END Ecode6WEDF100;

PROCEDURE Addscode*;
    VAR i,j,z, k, interrupted, interrupter, adr, fxp, start, to, from, opt, stop: INTEGER;
BEGIN
    start := FIQMachine4.NINS;
    stop := -1;
    fxp := -1;
    i := 0; opt := 0;
    j := 0;
    (* first block NOP *)
    WHILE stop # 0 DO
        WHILE FIQMachine4.program[i].opcode # FIQMachine4.FUTURE DO INC(i) END; 
        stop := FIQMachine4.program[i].arg2;
        INC(i);
        (* assert op = nop , replace with jump*)
        HLog.Int(start); 
        FIQMachine4.SetSystemCodeJump(i, start);
        INC(i);
        (*go through trace *)
        INC(j); (* skip interrupt trace notification *)
        IF NOP THEN (* look for possible preemption avoidance *)
            interrupter := FIQMachine4.traces[j].to;
            interrupted := FIQMachine4.traces[j].from;
            IF interrupted # -1 THEN
                k := j+1;
                WHILE FIQMachine4.traces[k].time >= 0 DO (* search in actual rection if swap is possible *)
                    to := FIQMachine4.traces[k].to;
                    from := FIQMachine4.traces[k].from;
                    IF interrupted = to THEN (* swap dispatches *)
                        HLog.Int(interrupted);
                        FIQMachine4.SystemCode(FIQMachine4.DISPATCH, interrupted, DELTA, fxp); (*  fixed up *)
                        fxp := FIQMachine4.NINS - 1;
                        INC(opt);
                    END;
                    INC(k);
                END;
            END;
        END;
        WHILE FIQMachine4.traces[j].time >= 0 DO 
            to := FIQMachine4.traces[j].to;
            from := FIQMachine4.traces[j].from;
            IF to = -1 THEN (* nothing to do *)
                HLog.Int(FIQMachine4.NINS);
                FIQMachine4.SystemCode(FIQMachine4.IDLE, DELTA, -1, -1);
            ELSE
                FIQMachine4.SystemCode(FIQMachine4.DISPATCH, to, DELTA, fxp); (*  fixed up *)
                fxp := FIQMachine4.NINS - 1;
            END;
            INC(j);
            interrupted := from;
            interrupter := to;
        END;
        FIQMachine4.SystemCode(FIQMachine4.IDLE, DELTA, -1, -1); (* just for safety *)
        FIQMachine4.SystemCode(FIQMachine4.RET, -1, -1, -1);
        (* Fixup *)
        WHILE fxp # -1 DO
            adr := FIQMachine4.program[fxp].arg3;
            HLog.Int(adr);
            FIQMachine4.SetSystemCodeFxp(fxp, FIQMachine4.NINS-1);
            fxp := adr;
        END;
        start :=  FIQMachine4.NINS;
    END;
    HLog.Ln; HLog.Str("Instructions: "); HLog.Int(FIQMachine4.NINS); HLog.Str(" optimizations: "); HLog.Int(opt);HLog.Ln;   
END Addscode;

PROCEDURE AddNPScode*;
BEGIN
    NOP := TRUE;
    Addscode;
END AddNPScode;

PROCEDURE AddScode*;
BEGIN
    NOP := FALSE;
    Addscode;
END AddScode;

PROCEDURE ShowTrace*;
    VAR i: INTEGER;
BEGIN i := 0;
    WHILE (i < FIQMachine4.MAXTRACE) & (FIQMachine4.traces[i].time # -2) DO
        HLog.Int(FIQMachine4.traces[i].time); HLog.Ch(":"); HLog.Int(FIQMachine4.traces[i].from);
        HLog.Ch(","); HLog.Int(FIQMachine4.traces[i].to); 
        IF FIQMachine4.traces[i].c THEN HLog.Ch("c"); END;
        HLog.Ln;INC(i);
    END
END ShowTrace;

PROCEDURE ShowPrg*;
    VAR i: INTEGER;
BEGIN i := 0;
    WHILE (i < FIQMachine4.NINS) DO
        HLog.Int(i); HLog.Ch(":"); 
        HLog.Int(FIQMachine4.program[i].opcode); HLog.Ch(" "); HLog.Int(FIQMachine4.program[i].arg1);
        HLog.Ch(","); HLog.Int(FIQMachine4.program[i].arg2);HLog.Ch(","); HLog.Int(FIQMachine4.program[i].arg3); 
        HLog.Ln;
        INC(i);
    END
END ShowPrg;

END MachineTest.

MachineTest.Ecode6EDF4
MachineTest.Ecode6EDF10
MachineTest.Ecode6EDF50
MachineTest.Ecode6EDF100

(* bigger WCET *)
MachineTest.Ecode6WEDF4
MachineTest.Ecode6WEDF10
MachineTest.Ecode6WEDF50
MachineTest.Ecode6WEDF100

(* smaller WCET *)
MachineTest.Ecode6wEDF4
MachineTest.Ecode6wEDF10
MachineTest.Ecode6wEDF50
MachineTest.Ecode6wEDF100

(*  inverted dispatches i.e. 1/RM *)
MachineTest.Ecode6EDF4B (* HAVE OVERRUN *)
MachineTest.Ecode6EDF10B
MachineTest.Ecode6EDF50B
MachineTest.Ecode6EDF100B

MachineTest.AddScode 
MachineTest.AddNPScode 

MachineTest.ShowPrg
MachineTest.ShowTrace

FIQMachine4.Start
FIQMachine4.Stop

PROCEDURE Ecode0*;
BEGIN
    LEDON := 800000;
    (* Define running tasks *)
    tasks[0] := On;
    tasks[1] := On2;
    NTSK := 2;
    
    (* Setup Ecode *)
    NINS := 0;
    SystemCode(SCHEDULE, 0, 2000, -1);
    SystemCode(SCHEDULE, 1, 1000, -1);
    SystemCode(FUTURE, 1000, 6, -1);
    SystemCode(DISPATCH, 1, 1000, 5);
    SystemCode(DISPATCH, 0, 1000, 5);
    SystemCode(RET, -1, -1, -1); 
    
    SystemCode(SCHEDULE, 1, 1000, -1);
    SystemCode(FUTURE, 1000, 0, -1);
    SystemCode(DISPATCH, 1, 1000, 10);
    SystemCode(DISPATCH, 0, 1000, 10);
    SystemCode(RET, -1, -1, -1);    
    
END Ecode0;


PROCEDURE Ecode0np*;
BEGIN
    LEDON := 800000;
    (* Define running tasks *)
    tasks[0] := On;
    tasks[1] := On2;
    NTSK := 2;
    
    (* Setup Ecode *)
    NINS := 0;
    SystemCode(SCHEDULE, 0, 2000, -1);
    SystemCode(SCHEDULE, 1, 1000, -1);
    SystemCode(FUTURE, 1000, 6, -1);
    SystemCode(DISPATCH, 1, 1000, 5);
    SystemCode(DISPATCH, 0, 1000, 5);
    SystemCode(RET, -1, -1, -1); 
    
    SystemCode(SCHEDULE, 1, 1000, -1);
    SystemCode(FUTURE, 1000, 0, -1);
    SystemCode(DISPATCH, 0, 1000, 10);
    SystemCode(DISPATCH, 1, 1000, 10);
    SystemCode(RET, -1, -1, -1);    
END Ecode0np;
PROCEDURE EcodeT10opt*;
BEGIN
    LEDON := 20000;
    (* Define running tasks *)
    tasks[0] := Led;
    tasks[1] := Led2;
    tasks[2] := Led;
    tasks[3] := Led2;
    tasks[4] := Led;
    tasks[5] := Led2;
    tasks[6] := Led;
    tasks[7] := Led2;
    tasks[8] := Led;
    tasks[9] := Led2;
    NTSK := 10;
    
    (* Setup Ecode *)
    NINS := 0;
    SystemCode(SCHEDULE, 0, 2000, -1);
    SystemCode(SCHEDULE, 1, 2000, -1);
    SystemCode(SCHEDULE, 2, 2000, -1);
    SystemCode(SCHEDULE, 3, 2000, -1);
    SystemCode(SCHEDULE, 4, 2000, -1);
    SystemCode(SCHEDULE, 5, 1000, -1);
    SystemCode(SCHEDULE, 6, 1000, -1);
    SystemCode(SCHEDULE, 7, 1000, -1);
    SystemCode(SCHEDULE, 8, 1000, -1);
    SystemCode(SCHEDULE, 9, 1000, -1);
    SystemCode(FUTURE, 1000, 22, -1);
    SystemCode(DISPATCH, 5, 1000, 21);
    SystemCode(DISPATCH, 6, 1000, 21);
    SystemCode(DISPATCH, 7, 1000, 21);
    SystemCode(DISPATCH, 8, 1000, 21);
    SystemCode(DISPATCH, 9, 1000, 21);
    SystemCode(DISPATCH, 0, 1000, 21);
    SystemCode(DISPATCH, 1, 1000, 21);
    SystemCode(DISPATCH, 2, 1000, 21);
    SystemCode(DISPATCH, 3, 1000, 21);
    SystemCode(DISPATCH, 4, 1000, 21);
    SystemCode(RET, -1, -1, -1); 
    SystemCode(SCHEDULE, 5, 1000, -1);
    SystemCode(SCHEDULE, 6, 1000, -1);
    SystemCode(SCHEDULE, 7, 1000, -1);
    SystemCode(SCHEDULE, 8, 1000, -1);
    SystemCode(SCHEDULE, 9, 1000, -1);
    SystemCode(FUTURE, 1000, 0, -1);
    SystemCode(DISPATCH, 5, 1000, 38);
    SystemCode(DISPATCH, 6, 1000, 38);
    SystemCode(DISPATCH, 7, 1000, 38);
    SystemCode(DISPATCH, 8, 1000, 38);
    SystemCode(DISPATCH, 9, 1000, 38);
    SystemCode(DISPATCH, 0, 1000, 38);
    SystemCode(DISPATCH, 1, 1000, 38);
    SystemCode(DISPATCH, 2, 1000, 38);
    SystemCode(DISPATCH, 3, 1000, 38);
    SystemCode(DISPATCH, 4, 1000, 38);
    SystemCode(RET, -1, -1, -1);
END EcodeT10opt;
